Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryServiceImpl.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryServiceImpl.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryServiceImpl.java	(revision 61441)
@@ -442,14 +547,48 @@
             repository.setId("openaire____::issn" + repository.getIssn());
             repository.setNamespacePrefix("issn" + repository.getIssn());
             this.storeRepository(repository, SecurityContextHolder.getContext().getAuthentication());
-        }else if (datatype.equals("aggregator")) {
+        } else if (datatype.equals("aggregator")) {
             repository.setId("openaire____::" + com.unboundid.util.Base64.encode(repository.getOfficialName()));
-            repository.setNamespacePrefix(DigestUtils.md5Hex(repository.getOfficialName()).substring(0,12));
+            repository.setNamespacePrefix(DigestUtils.md5Hex(repository.getOfficialName()).substring(0, 12));
             this.storeRepository(repository, SecurityContextHolder.getContext().getAuthentication());
-        }else {
+        } else {
             this.latentUpdate(repository, SecurityContextHolder.getContext().getAuthentication());
         }
 
+        // TODO: move the following code elsewhere (creation and assignment of role to user) ??
+        // Create new role
+        String newRoleName = roleMappingService.getRoleIdByRepoId(repository.getId());
+        Role newRole = new Role(newRoleName, repository.getOfficialName());
+        Integer couId = null;
+        try {
+            couId = registryCalls.createRole(newRole);
+        } catch (HttpClientErrorException e) {
+            couId = registryCalls.getCouId(newRoleName);
+            if (couId == null) {
+                LOGGER.error(String.format("Could not create role '%s'", newRoleName), e);
+            }
+        } catch (Exception e) {
+            LOGGER.error(String.format("Could not create role '%s'", newRoleName), e);
+            throw e;
+        }
+
+        // Assign new role to the user that created it
+        Integer coPersonId = registryCalls.getCoPersonIdByIdentifier();
+        if (couId != null) {
+            Integer role = registryCalls.getRoleId(coPersonId, couId);
+            try {
+                registryCalls.assignMemberRole(coPersonId, couId, role);
+
+                // Add role to current user authorities
+                authoritiesUpdater.addRole(roleMappingService.convertRepoIdToAuthority(repository.getId()));
+            } catch (Exception e) {
+                LOGGER.debug("Exception on assign role to user during add repository", e);
+                throw e;
+            }
+
+        }
+
+
         return repository;
     }
 
@@ -465,17 +604,17 @@
             LOGGER.debug("JSON to add(update) -> " + json_repository);
 
             HttpEntity<String> httpEntity = new HttpEntity<String>(json_repository, httpHeaders);
-            ResponseEntity responseEntity = restTemplate.exchange(uriComponents.toUri(),HttpMethod.POST, httpEntity, ResponseEntity.class);
+            ResponseEntity responseEntity = restTemplate.exchange(uriComponents.toUri(), HttpMethod.POST, httpEntity, ResponseEntity.class);
 
             if (responseEntity.getStatusCode().equals(HttpStatus.OK)) {
-                emailUtils.sendUserRegistrationEmail(repository, authentication);
-                emailUtils.sendAdminRegistrationEmail(repository, authentication);
+//                emailUtils.sendUserRegistrationEmail(repository, authentication);
+//                emailUtils.sendAdminRegistrationEmail(repository, authentication);
             } else
                 LOGGER.debug(responseEntity.getBody().toString());
 
             return repository;
         } catch (Exception e) {
-            LOGGER.debug("Exception on updateRepository" , e);
+            LOGGER.debug("Exception on updateRepository", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -484,7 +623,7 @@
     }
 
     @Override
-    public Repository updateRepository(Repository repository,Authentication authentication) throws Exception {
+    public Repository updateRepository(Repository repository, Authentication authentication) throws Exception {
         UriComponents uriComponents = UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/update/")
                 .build()
@@ -496,7 +635,7 @@
             LOGGER.debug("JSON to update -> " + json_repository);
 
             HttpEntity<String> httpEntity = new HttpEntity<String>(json_repository, httpHeaders);
-            ResponseEntity responseEntity = restTemplate.exchange(uriComponents.toUri(),HttpMethod.POST, httpEntity
+            ResponseEntity responseEntity = restTemplate.exchange(uriComponents.toUri(), HttpMethod.POST, httpEntity
                     , ResponseEntity.class);
 
             if (responseEntity.getStatusCode().equals(HttpStatus.OK)) {
@@ -507,7 +646,7 @@
 
             return repository;
         } catch (Exception e) {
-            LOGGER.debug("Exception on updateRepository" , e);
+            LOGGER.debug("Exception on updateRepository", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -526,10 +665,10 @@
                 .build()
                 .encode();
         String json_repository = Converter.repositoryObjectToJson(repository);
-        HttpEntity<String> httpEntity = new HttpEntity <String> (json_repository,httpHeaders);
-        ResponseEntity responseEntity = restTemplate.exchange(uriComponents.toUri(),HttpMethod.POST, httpEntity, ResponseEntity.class);
+        HttpEntity<String> httpEntity = new HttpEntity<String>(json_repository, httpHeaders);
+        ResponseEntity responseEntity = restTemplate.exchange(uriComponents.toUri(), HttpMethod.POST, httpEntity, ResponseEntity.class);
 
-        if(responseEntity.getStatusCode().equals(HttpStatus.OK)) {
+        if (responseEntity.getStatusCode().equals(HttpStatus.OK)) {
             emailUtils.sendUserRegistrationEmail(repository, authentication);
             emailUtils.sendAdminRegistrationEmail(repository, authentication);
         } else {
@@ -538,8 +677,8 @@
     }
 
     @Override
-    public void deleteRepositoryInterface(String id ,
-                                          String registeredBy){
+    public void deleteRepositoryInterface(String id,
+                                          String registeredBy) {
         UriComponents uriComponents = UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/api/")
                 .path("/{id}")
@@ -555,8 +694,8 @@
                                                       String comment, RepositoryInterface repositoryInterface) throws Exception {
         try {
             Repository e = this.getRepositoryById(repoId);
-            repositoryInterface = createRepositoryInterface(e,repositoryInterface,datatype);
-            String json_interface = Converter.repositoryInterfaceObjectToJson(e,repositoryInterface);
+            repositoryInterface = createRepositoryInterface(e, repositoryInterface, datatype);
+            String json_interface = Converter.repositoryInterfaceObjectToJson(e, repositoryInterface);
 
             UriComponents uriComponents = UriComponentsBuilder
                     .fromHttpUrl(baseAddress + "/ds/api/add/")
@@ -563,9 +702,9 @@
                     .build()
                     .encode();
 
-            HttpEntity<String> httpEntity = new HttpEntity <> (json_interface,httpHeaders);
+            HttpEntity<String> httpEntity = new HttpEntity<>(json_interface, httpHeaders);
 
-            restTemplate.postForObject(uriComponents.toUri(),httpEntity, String.class);
+            restTemplate.postForObject(uriComponents.toUri(), httpEntity, String.class);
 
             emailUtils.sendAdminRegisterInterfaceEmail(e, comment, repositoryInterface, SecurityContextHolder.getContext().getAuthentication());
             emailUtils.sendUserRegisterInterfaceEmail(e, comment, repositoryInterface, SecurityContextHolder.getContext().getAuthentication());
@@ -575,7 +714,7 @@
             return repositoryInterface;
 
         } catch (Exception e) {
-            LOGGER.error("Exception on addRepositoryInterface" , e);
+            LOGGER.error("Exception on addRepositoryInterface", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -586,15 +725,20 @@
                                                          String registeredBy,
                                                          String comment, RepositoryInterface repositoryInterface) throws Exception {
 
-        this.updateBaseUrl(repoId,repositoryInterface.getId(),repositoryInterface.getBaseUrl());
-        this.updateCompliance(repoId,repositoryInterface.getId(),repositoryInterface.getCompliance());
-        this.updateValidationSet(repoId,repositoryInterface.getId(),repositoryInterface.getAccessSet());
+        this.updateBaseUrl(repoId, repositoryInterface.getId(), repositoryInterface.getBaseUrl());
+        this.updateCompliance(repoId, repositoryInterface.getId(), repositoryInterface.getCompliance());
+        this.updateValidationSet(repoId, repositoryInterface.getId(), repositoryInterface.getAccessSet());
 
-        Repository e = this.getRepositoryById(repoId);
-        emailUtils.sendAdminUpdateInterfaceEmail(e, comment, repositoryInterface, SecurityContextHolder.getContext().getAuthentication());
-        emailUtils.sendUserUpdateInterfaceEmail(e, comment, repositoryInterface, SecurityContextHolder.getContext().getAuthentication());
-        submitInterfaceValidation(getRepositoryById(repoId),registeredBy,repositoryInterface,true);
+        Repository repository = this.getRepositoryById(repoId);
+        try {
+            emailUtils.sendAdminUpdateInterfaceEmail(repository, comment, repositoryInterface, SecurityContextHolder.getContext().getAuthentication());
+            emailUtils.sendUserUpdateInterfaceEmail(repository, comment, repositoryInterface, SecurityContextHolder.getContext().getAuthentication());
+        } catch (Exception e) {
+            LOGGER.warn("Could not send emails", e);
+        }
 
+        submitInterfaceValidation(getRepositoryById(repoId), registeredBy, repositoryInterface, true);
+
         return repositoryInterface;
     }
 
@@ -665,7 +809,7 @@
 
     @Override
     public List<Timezone> getTimezones() {
-        List<String> timezones =  Converter.readFile("timezones.txt");
+        List<String> timezones = Converter.readFile("timezones.txt");
         return Converter.toTimezones(timezones);
     }
 
@@ -672,18 +816,18 @@
     @Override
     public List<String> getUrlsOfUserRepos(String userEmail,
                                            String page,
-                                           String size){
+                                           String size) {
         UriComponents uriComponents = UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/api/baseurl/")
                 .path("/{page}/{size}")
-                .build().expand(page,size).encode();
+                .build().expand(page, size).encode();
 
-        try{
+        try {
             RequestFilter requestFilter = new RequestFilter();
             requestFilter.setRegisteredby(userEmail);
-            return Arrays.asList(restTemplate.postForObject(uriComponents.toUri(),requestFilter, String[].class));
-        }catch (Exception e){
-            LOGGER.debug("Exception on addRepositoryInterface" , e);
+            return Arrays.asList(restTemplate.postForObject(uriComponents.toUri(), requestFilter, String[].class));
+        } catch (Exception e) {
+            LOGGER.debug("Exception on addRepositoryInterface", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -723,7 +867,7 @@
 
 
     @Override
-    public Map<String, String> getCompatibilityClasses(String mode)  {
+    public Map<String, String> getCompatibilityClasses(String mode) {
 
         LOGGER.debug("Getting compatibility classes for mode: " + mode);
         Map<String, String> retMap = new HashMap<String, String>();
@@ -752,7 +896,7 @@
     }
 
     @Override
-    public Map<String, String> getDatasourceClasses(String mode)  {
+    public Map<String, String> getDatasourceClasses(String mode) {
 
         LOGGER.debug("Getting datasource classes for mode: " + mode);
 
@@ -773,16 +917,16 @@
                     retMap.put(entry.getKey(), entry.getValue());
             }
         }
-        return filterResults(retMap,mode);
+        return filterResults(retMap, mode);
 
     }
 
-    private Map<String,String> filterResults(Map<String, String> map,String mode) {
+    private Map<String, String> filterResults(Map<String, String> map, String mode) {
 
-        HashMap<String,String> filteredMap = new HashMap<>();
-        for(String key:map.keySet())
-            if(dataSourceClass.get(mode).contains(key))
-                filteredMap.put(key,map.get(key));
+        HashMap<String, String> filteredMap = new HashMap<>();
+        for (String key : map.keySet())
+            if (dataSourceClass.get(mode).contains(key))
+                filteredMap.put(key, map.get(key));
 
         return filteredMap;
     }
@@ -810,23 +954,23 @@
 
     @Override
     public Map<String, String> getListLatestUpdate(String mode) throws JSONException {
-        if(mode.equals("opendoar"))
-            return Collections.singletonMap("lastCollectionDate", getRepositoryInterface("openaire____::"+mode).get(0).getLastCollectionDate());
+        if (mode.equals("opendoar"))
+            return Collections.singletonMap("lastCollectionDate", getRepositoryInterface("openaire____::" + mode).get(0).getLastCollectionDate());
         else
             /*
-            * first api of re3data has null value on collection date
-            * */
-            return Collections.singletonMap("lastCollectionDate", getRepositoryInterface("openaire____::"+mode).get(1).getLastCollectionDate());
+             * first api of re3data has null value on collection date
+             * */
+            return Collections.singletonMap("lastCollectionDate", getRepositoryInterface("openaire____::" + mode).get(1).getLastCollectionDate());
     }
 
     private void updateValidationSet(String repositoryId, String repositoryInterfaceId, String validationSet) throws Exception {
         UriComponents uriComponents = UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/api/oaiset")
-                .queryParam("dsId",repositoryId)
-                .queryParam("apiId",repositoryInterfaceId)
-                .queryParam("oaiSet",validationSet)
+                .queryParam("dsId", repositoryId)
+                .queryParam("apiId", repositoryInterfaceId)
+                .queryParam("oaiSet", validationSet)
                 .build().encode();
-       restTemplate.exchange(uriComponents.toUri(),HttpMethod.POST, null, ResponseEntity.class);
+        restTemplate.exchange(uriComponents.toUri(), HttpMethod.POST, null, ResponseEntity.class);
 
     }
 
@@ -834,21 +978,21 @@
     private void updateBaseUrl(String repositoryId, String repositoryInterfaceId, String baseUrl) {
         UriComponents uriComponents = UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/api/baseurl")
-                .queryParam("dsId",repositoryId)
-                .queryParam("apiId",repositoryInterfaceId)
-                .queryParam("baseUrl",baseUrl)
+                .queryParam("dsId", repositoryId)
+                .queryParam("apiId", repositoryInterfaceId)
+                .queryParam("baseUrl", baseUrl)
                 .build().encode();
-        restTemplate.postForObject(uriComponents.toUri(),null,String.class);
+        restTemplate.postForObject(uriComponents.toUri(), null, String.class);
     }
 
-    private void updateCompliance(String repositoryId, String repositoryInterfaceId,String compliance) {
+    private void updateCompliance(String repositoryId, String repositoryInterfaceId, String compliance) {
         UriComponents uriComponents = UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/api/compliance")
-                .queryParam("dsId",repositoryId)
-                .queryParam("apiId",repositoryInterfaceId)
-                .queryParam("compliance",compliance)
+                .queryParam("dsId", repositoryId)
+                .queryParam("apiId", repositoryInterfaceId)
+                .queryParam("compliance", compliance)
                 .build().encode();
-        restTemplate.postForObject(uriComponents.toUri(),null,String.class);
+        restTemplate.postForObject(uriComponents.toUri(), null, String.class);
     }
 
     private MetricsNumbers getMetricsNumbers(String openAIREID) throws BrokerException {
@@ -869,7 +1013,7 @@
                     new ParameterizedTypeReference<MetricsNumbers>() {
                     });
         } catch (RestClientException e) {
-            LOGGER.debug("Exception on getMetricsNumbers" , e);
+            LOGGER.debug("Exception on getMetricsNumbers", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -886,39 +1030,58 @@
         return null;
     }
 
-    private UriComponents searchDatasource(String page,String size){
+    private UriComponents searchDatasource(String page, String size) {
 
         return UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/search/")
                 .path("/{page}/{size}/")
-                .queryParam("requestSortBy","officialname")
-                .queryParam("order","ASCENDING")
+                .queryParam("requestSortBy", "officialname")
+                .queryParam("order", "ASCENDING")
                 .build().expand(page, size).encode();
     }
 
-    private UriComponents searchSnipperDatasource(String page,String size){
+    private UriComponents searchSnipperDatasource(String page, String size) {
 
         return UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/searchsnippet/")
                 .path("/{page}/{size}/")
-                .queryParam("requestSortBy","officialname")
-                .queryParam("order","ASCENDING")
+                .queryParam("requestSortBy", "officialname")
+                .queryParam("order", "ASCENDING")
                 .build().expand(page, size).encode();
     }
 
-    private UriComponents searchRegisteredDatasource(String requestSortBy, String order, String page,String size){
+    private UriComponents searchRegisteredDatasource(String requestSortBy, String order, String page, String size) {
 
         return UriComponentsBuilder
                 .fromHttpUrl(baseAddress + "/ds/searchregistered/")
                 .path("/{page}/{size}/")
-                .queryParam("requestSortBy",requestSortBy)
-                .queryParam("order",order)
+                .queryParam("requestSortBy", requestSortBy)
+                .queryParam("order", order)
                 .build().expand(page, size).encode();
     }
 
-    private String getRepositoryType(String typology){
+    private String getRepositoryType(String typology) {
         return invertedDataSourceClass.get(typology);
     }
 
+    private List<String> getRoleIdsFromUserRoles(String userEmail) {
+        Integer coPersonId = registryCalls.getCoPersonIdByEmail(userEmail);
+        JsonArray roles;
+        ArrayList<String> roleIds = new ArrayList<>();
+        ArrayList<Integer> couIds = new ArrayList<>();
+        if (coPersonId != null) {
+            roles = registryCalls.getRolesWithStatus(coPersonId, AaiRegistryService.RoleStatus.ACTIVE);
+            for (JsonElement role : roles) {
+                JsonObject object = role.getAsJsonObject();
+                if (object.get("CouId") == null) {
+                    continue;
+                }
+                couIds.add(object.get("CouId").getAsInt());
+            }
 
+            roleIds.addAll(registryCalls.getCouNames(couIds).values());
+
+        }
+        return roleIds;
+    }
 }
Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/PiWikServiceImpl.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/PiWikServiceImpl.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/PiWikServiceImpl.java	(revision 61441)
@@ -75,7 +75,7 @@
     }
 
     @Override
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or (hasRole('ROLE_USER') and #piwikInfo.requestorEmail == authentication.userInfo.email)")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or (hasAuthority('REGISTERED_USER') and #piwikInfo.requestorEmail == authentication.userInfo.email)")
     public PiwikInfo savePiwikInfo(PiwikInfo piwikInfo) {
         JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);
         jdbcTemplate.update(INSERT_PIWIK_INFO, new Object[]{piwikInfo.getRepositoryId(), piwikInfo.getSiteId(), piwikInfo.getRequestorName(),
@@ -144,7 +144,7 @@
     }
 
     @Override
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN')")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
     public ResponseEntity<Object> approvePiwikSite(String repositoryId) {
         new JdbcTemplate(dataSource).update(APPROVE_PIWIK_SITE, new Object[] {repositoryId}, new int[] {Types.VARCHAR});
         return new ResponseEntity<>("OK",HttpStatus.OK);
@@ -158,7 +158,7 @@
     }
 
     @Override
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN')")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR')")
     public ResponseEntity<Object> markPiwikSiteAsValidated(String repositoryId) throws RepositoryServiceException {
         try {
             approvePiwikSite(repositoryId);
@@ -179,7 +179,7 @@
     }
 
     @Override
-    @PreAuthorize("hasRole('ROLE_ADMIN') or hasRole('ROLE_PROVIDE_ADMIN') or (hasRole('ROLE_USER') and #piwikInfo.requestorEmail == authentication.userInfo.email)")
+    @PreAuthorize("hasAuthority('SUPER_ADMINISTRATOR') or hasAuthority('CONTENT_PROVIDER_DASHBOARD_ADMINISTRATOR') or (hasAuthority('REGISTERED_USER') and #piwikInfo.requestorEmail == authentication.userInfo.email)")
     public PiwikInfo enableMetricsForRepository(String officialName,
                                                 String repoWebsite,
                                                 PiwikInfo piwikInfo) throws RepositoryServiceException {
